/*
Author :  AA-Team - http://themeforest.net/user/AA-Team
*/

// Initialization and events code for the app
WooZoneVCSearch_frontend = (function ($) {
    "use strict";

    var maincontainer = null, response_elm = null, paged = 1, per_page = 10, placeholder = '', type = '', callback_ids = [], all_asins = [], asins_need_to_be_loaded = [], asins_loaded = [], custom_list_paged = 0, current_asin_for_search = '';
    
    // init function, autoload
    (function init() {
    
        // load the triggers
        $(document).ready(function(){
            maincontainer = $(".WooZoneVCSearch-amazon-products");
            var wrapper = $(".WooZoneVCSearch-amazon-products-wrapper");

            var where = maincontainer.data('where');
            var current_case = null;

            type = maincontainer.data('type');
            current_case = 'shortcode';
            
            response_elm = maincontainer.find(".WooZoneVCSearch-amazon-response");

            per_page = maincontainer.data('perpage');
            placeholder = maincontainer.data('placeholder');
            
            triggers();
        });
    })();

    var Pagination = {

        code: '',

        // converting initialize data
        Extend: function(data) {
            data = data || {};
            Pagination.size = data.size || 300;
            Pagination.page = data.page || 1;
            Pagination.boxid = data.boxid || '';
            Pagination.step = data.step || 3;
        },

        // add pages by number (from [s] to [f])
        Add: function(s, f) {
            for (var i = s; i < f; i++) {
                Pagination.code += '<a>' + i + '</a>';
            }
        },

        // add last page with separator
        Last: function() {
            Pagination.code += '<i>...</i><a>' + Pagination.size + '</a>';
        },

        // add first page with separator
        First: function() {
            Pagination.code += '<a>1</a><i>...</i>';
        },


        Click: function() {
            Pagination.page = +this.innerHTML;
            Pagination.Start();
            paged = Pagination.page;

            search_for_products( maincontainer, Pagination.boxid );
        },

        Prev: function() {
            Pagination.page--;
            if (Pagination.page < 1) {
                Pagination.page = 1;
            }
            //Pagination.Start();

            paged = Pagination.page;

            search_for_products( maincontainer, Pagination.boxid );
        },

        Next: function() {
            Pagination.page++;
            if (Pagination.page > Pagination.size) {
                Pagination.page = Pagination.size;
            }
            //Pagination.Start();

            paged = Pagination.page;

            search_for_products( maincontainer, Pagination.boxid );
        },

        Bind: function() {
            var a = Pagination.e.getElementsByTagName('a');
            for (var i = 0; i < a.length; i++) {
                if (+a[i].innerHTML === Pagination.page) a[i].className = 'current';
                a[i].addEventListener('click', Pagination.Click, false);
            }
        },

        Finish: function() {
            Pagination.e.innerHTML = Pagination.code;
            Pagination.code = '';
            Pagination.Bind();
        },

        Start: function() {
            if (Pagination.size < Pagination.step * 2 + 6) {
                Pagination.Add(1, Pagination.size + 1);
            }
            else if (Pagination.page < Pagination.step * 2 + 1) {
                Pagination.Add(1, Pagination.step * 2 + 4);
                Pagination.Last();
            }
            else if (Pagination.page > Pagination.size - Pagination.step * 2) {
                Pagination.First();
                Pagination.Add(Pagination.size - Pagination.step * 2 - 2, Pagination.size + 1);
            }
            else {
                Pagination.First();
                Pagination.Add(Pagination.page - Pagination.step, Pagination.page + Pagination.step + 1);
                Pagination.Last();
            }
            Pagination.Finish();
        },

        Buttons: function(e) {
            var nav = e.getElementsByTagName('a');
            nav[0].addEventListener('click', Pagination.Prev, false);
            nav[1].addEventListener('click', Pagination.Next, false);
        },

        Create: function(e) {

            var html = [
                '<a class="WooZoneVCSearch_prev_page">&#9668; ' + WooZoneVCSearch_custom.translation.prev_page + '</a>', // previous button
                //'<span></span>',  // pagination container
                '<a class="WooZoneVCSearch_next_page">' + WooZoneVCSearch_custom.translation.next_page + ' &#9658;</a>'  // next button
            ];

            e.innerHTML = html.join('');
            Pagination.e = e.getElementsByTagName('span')[0];
            Pagination.Buttons(e);
        },

        // init
        Init: function(e, data) {
            Pagination.Extend(data);
            Pagination.Create(e);
            //Pagination.Start();
        }
    }

    function build_rating()
    {
        $(".WooZoneVCSearch-rating").starRating({
            totalStars: 5,
            starShape: 'rounded',
            starSize: 18,
            strokeWidth: 0,
            readOnly: true,
            emptyColor: '#f0f0f0',
            strokeColor: '#f8c90e',
            starGradient: {
                start: '#f8c90e',
                end: '#f8c90e'
            },
            useGradient: true
        });
    }

    function search_for_one_product( that, box_id, asin )
    {
        var api_url = that.data('apiurl'),
            SearchIndex = that.data('searchindex');
            
        api_url = api_url.replace( '{Keywords}', asin );
        api_url = api_url.replace( '{paged}', 0 );
        api_url = api_url.replace( '{items_per_page}', 1 );
        api_url = api_url.replace( '{SearchIndex}', SearchIndex );
        api_url = api_url.replace( '{InstanceId}', box_id );

        //api_url = api_url.replace( 'search_callback', 'callback_' + box_id );

        current_asin_for_search = asin;

        // debug
        //console.log( api_url );

        response_elm.append( '<div class="WooZoneVCSearch-loader"></div>' );
        
        $.ajax({
            url: api_url,
            dataType: 'jsonp',
            jsonpCallback: 'search_callback',
            error: function( jqXHR, textStatus, errorThrown ) {
                response_elm.html('<div class="WooZoneVCSearch-no-results-found">' + WooZoneVCSearch_custom.translation.no_results_found + '</div>');
                maincontainer.find('.WooZoneVCSearch_prev_page').css('border-right', '1px solid #d1d3d4');
                maincontainer.find('.WooZoneVCSearch_next_page').hide();
            }
        });
    }

    function search_for_products_rss( that, box_id, type )
    {
        var keyword = that.data('keyword'),
            api_url = that.data('apiurl'),
            browsenode = that.data('browsenode'),
            SearchIndex = that.data('searchindex');

        SearchIndex = SearchIndex.toLowerCase();
        api_url = api_url.replace( '{SearchIndex}', SearchIndex );

        if( type == 'bestsellers' ){
            // https://www.amazon.com/gp/rss/bestsellers/boost/12034492011/
            if( browsenode > 0 ){
                api_url = api_url.replace( "?", "/" + ( browsenode ) + "/?" );
            }
        }

        //api_url = 'https://www.amazon.com/Best-Sellers-Amazon-Launchpad-Food/zgbs/boost/12034492011/ref=zg_bs_pg_3?_encoding=UTF8&pg=3&ajax=1';
        var orig_url = api_url;
        api_url = 'https://query.yahooapis.com/v1/public/yql?q=select * from data.headers where url="' + ( encodeURIComponent( api_url ) ) + '"&format=json&diagnostics=true&env=store://datatables.org/alltableswithkeys&callback=' + 'callback_' + box_id;

        // debug
        //console.log( orig_url, api_url );

        response_elm.append( '<div class="WooZoneVCSearch-loader"></div>' );
        
        $.ajax({
            url: api_url,
            dataType: 'jsonp',
            jsonpCallback: 'callback_' + box_id,
            error: function( jqXHR, textStatus, errorThrown ) {
            	response_elm.html('<div class="WooZoneVCSearch-no-results-found">' + WooZoneVCSearch_custom.translation.no_results_found + '</div>');
            	//maincontainer.find('.WooZoneVCSearch-number-results-found').hide();
            	maincontainer.find('.WooZoneVCSearch_prev_page').css('border-right', '1px solid #d1d3d4');
            	maincontainer.find('.WooZoneVCSearch_next_page').hide();
            }
        });
    }

    function search_for_products( that, box_id )
    {
        var keyword = that.data('keyword'),
            api_url = that.data('apiurl'),
            SearchIndex = that.data('searchindex');
            
        api_url = api_url.replace( '{Keywords}', keyword );
        api_url = api_url.replace( '{paged}', (paged > 1 ? ((paged-1) * per_page) : 0) );
        api_url = api_url.replace( '{items_per_page}', per_page );
        api_url = api_url.replace( '{SearchIndex}', SearchIndex );
        api_url = api_url.replace( '{InstanceId}', box_id );

        //api_url = api_url.replace( 'search_callback', 'callback_' + box_id );

        // debug
        //console.log( api_url );

        response_elm.append( '<div class="WooZoneVCSearch-loader"></div>' );
        
        $.ajax({
            url: api_url,
            dataType: 'jsonp',
            jsonpCallback: 'search_callback_multi',
            error: function( jqXHR, textStatus, errorThrown ) {
            	//response_elm.html('<div class="WooZoneVCSearch-no-results-found">' + WooZoneVCSearch_custom.translation.no_results_found + '</div>');
            	//maincontainer.find('.WooZoneVCSearch-number-results-found').hide();
            	//maincontainer.find('.WooZoneVCSearch_prev_page').css('border-right', '1px solid #d1d3d4');
            	//maincontainer.find('.WooZoneVCSearch_next_page').hide();
            }
        });
    }

    function build_pagination( total_results, boxid )
    {
        maincontainer.find(".WooZoneVCSearch-amazon-pag-response").html('<div id="WooZoneVCSearch-pagination"></div>');
        
        Pagination.Init( maincontainer.find("#WooZoneVCSearch-pagination")[0], {
            size: Math.floor( total_results / per_page ),
            page: paged, 
            step: 1,
            boxid: boxid
        });
        
        if( paged > 1 ) { 
			maincontainer.find('.WooZoneVCSearch_prev_page').show();
		}else{
        	maincontainer.find('.WooZoneVCSearch_prev_page').hide();
        }
    }

    function build_product_box( product, maincontainer, extra_class )
    {
        var html = [];

        //maincontainer.data('placeholder')
        if( product.Title == 'not found' ){
            html.push( '<div class="WooZoneVCSearch-product" data-asin="' + ( product.ASIN ) + '">' );
            html.push(  '<div class="WooZoneVCSearch-image"><a href="#not_found"><img src="' + ( maincontainer.data('placeholder') ) + '" /></a></div>' );
            html.push(  '<div class="WooZoneVCSearch-title"><a href="#not_found" class="WooZoneVCSearch-monitor-redirect"> Unable to find ' + ( product.ASIN ) + '</a></div>' );
            html.push( '</div>' );

            return html.join("\n");
        }

        if( product.LargeImageUrl == "" ){
            product.LargeImageUrl = placeholder;
        }

        if( typeof(product.LargeImageUrl) == "undefined" ){
            product.LargeImageUrl = product.ImageUrl;
        }

        html.push( '<div class="WooZoneVCSearch-product ' + ( extra_class ) + '" data-asin="' + ( product.ASIN ) + '">' );
        if( product.IsPrimeEligible > 0 ){
            html.push(  '<div class="WooZoneVCSearch-is-prime"></div>' );
        }

        var buyurl = maincontainer.data('buyurl').replace( "{ASIN}", product.ASIN );
        html.push(  '<div class="WooZoneVCSearch-image"><a href="' + ( buyurl ) + '" target="_blank" class="WooZoneVCSearch-monitor-redirect"><img src="' + ( product.LargeImageUrl ) + '" /></a></div>' );
        
        //category
        if( typeof(product.category) != "undefined" ){
            html.push(  '<div class="WooZoneVCSearch-subtitle">' + ( product.category ) + '</div>' );
        }else{
            html.push(  '<div class="WooZoneVCSearch-subtitle">' + ( product.Subtitle ) + '</div>' );
        }
        
        html.push(  '<div class="WooZoneVCSearch-title"><a href="' + ( buyurl ) + '" target="_blank" class="WooZoneVCSearch-monitor-redirect">' + ( product.Title ) + '</a></div>' );
        
        if( product.Rating != "" ){
            html.push(  '<div class="WooZoneVCSearch-rating" data-rating="' + ( product.Rating ) + '"></div>' );

            if( product.TotalReviews !== undefined ){
                html.push(  '<a href="#" class="WooZoneVCSearch-rating-totals">(' + ( product.TotalReviews ) + ')</a>' );
            }
        }
        html.push(  '<div class="WooZoneVCSearch-price">' );

        if( typeof(product.ListPrice) != "undefined" ){
            html.push(      '<div class="WooZoneVCSearch-old-price">' + ( product.ListPrice ) + '</div>' );
        }
        if( typeof(product.Price) != "undefined" ){
            html.push(      '<div class="WooZoneVCSearch-new-price">' + ( product.Price ) + '</div>' );
        }
        html.push(  '</div>' );
        html.push(  '<a href="' + ( buyurl ) + '" target="_blank" class="WooZoneVCSearch-button WooZoneVCSearch-monitor-redirect">' + ( maincontainer.data('btntext') ) + '</a>' );
        html.push( '</div>' );

        return html.join("\n");
    }

    function build_custom_list_pagination( perpage, total_results, maincontainer )
    {
        var html    = [],
            steps   = Math.ceil( total_results / perpage );

        html.push( '<div class="WooZoneVCSearch-custom-list-pagination" style="grid-column-end: span ' + ( maincontainer.data('column') ) + ';">' );
        var marker = 0;
        for (var cc = 0; cc < steps; cc++) {
            html.push( '<a href="#" data-paged="' + ( cc ) + '" class="' + ( custom_list_paged == cc ? 'is_on' : '' ) + '">' + ( perpage * marker + 1 ) + '-' + ( perpage * (marker + 1) ) + '</a>' );
            marker++;
        }
        html.push( '</div>' );
        

        return html.join( "\n" );
    }

    function build_feed_pagination( perpage, total_results, maincontainer )
    {
        var html    = [],
            steps   = Math.ceil( total_results / perpage );
  
        html.push( '<div class="WooZoneVCSearch-feed-pagination" style="grid-column-end: span ' + ( maincontainer.data('column') ) + ';">' );
        var marker = 0;
        for (var cc = 0; cc < steps; cc++) {

            var max_page = perpage * (marker + 1);
            if( max_page > total_results ){
                max_page = total_results;
            }
            var current_page = perpage * marker + 1;
            if( current_page == max_page ){
                html.push( '<a href="#" data-paged="' + ( cc ) + '" class="' + ( custom_list_paged == cc ? 'is_on' : '' ) + '">' + ( current_page ) + '</a>' );

            }else{
                html.push( '<a href="#" data-paged="' + ( cc ) + '" class="' + ( custom_list_paged == cc ? 'is_on' : '' ) + '">' + ( current_page ) + '-' + ( max_page ) + '</a>' );
               console.log(max_page );
            }
            marker++;
        }
        html.push( '</div>' );
        

        return html.join( "\n" );
    }

    function callback( boxid, data )
    {
        //console.log( boxid, data );
        var box = $(".WooZoneVCSearch-uniq-" + boxid ),
            type = box.data('type');

        if( type == 'search-box' ){
            box.each( function(){
                maincontainer = $(this);
                response_elm = maincontainer.find(".WooZoneVCSearch-amazon-response");

                var total_results   = data['NumRecords'],
                    results         = data['results'],
                    html            = [];
                
                if( total_results > 0 && results.length > 0 ){
                    maincontainer.find('.WooZoneVCSearch_next_page').show();
                    
                    $.each( results, function(key, value){
                        html.push( build_product_box( value, maincontainer ) );
                    });

                    response_elm.html( html.join("\n") );

                    build_rating();

                    if( maincontainer.data('showpagination') == 'yes' && total_results > per_page ){
                        build_pagination( total_results, boxid );
                    }
                }

                // debug ...
                //console.log( total_results, results, boxid );
            })
        }

        if( type == "custom-list" ){

            box.each( function(){
                maincontainer = $(this);
                response_elm = maincontainer.find(".WooZoneVCSearch-amazon-response");

                var showpagination  = maincontainer.data('showpagination'),
                perpage             = maincontainer.data('perpage'),
                total_results       = all_asins.length;

                asins_loaded[custom_list_paged].push( data['results'][0] );

                if( typeof(data['results']) == "undefined" || data['results'].length == 0 || current_asin_for_search != data['results'][0]['ASIN'] ){
                    asins_loaded[custom_list_paged].push({
                        'ASIN': current_asin_for_search,
                        'Title': 'not found'
                    });
                }

                asins_loaded[custom_list_paged] = asins_loaded[custom_list_paged].filter(function(n){ return n != undefined });
                //console.log(asins_loaded );
                if( asins_loaded[custom_list_paged].length < asins_need_to_be_loaded[custom_list_paged].length ){

                    var current_asin_index = -1;
                    $.each( asins_need_to_be_loaded[custom_list_paged], function( key, current_asin ){
                        

                        if( typeof(data['results'][0]) != "undefined" && current_asin == data['results'][0]['ASIN'] ){
                            current_asin_index = key;
                        }
                    });

                    //console.log( current_asin_index, asins_need_to_be_loaded[custom_list_paged] );
                    var next_asin = asins_need_to_be_loaded[custom_list_paged][current_asin_index + 1];
                    if( typeof(next_asin) != "undefined" ){
                        search_for_one_product( box, boxid, next_asin );
                    }
                }
                else{

                    // debug 
                    //console.log('done!' );
                    //console.log(asins_loaded );

                    var html = [];
                    $.each( asins_loaded[custom_list_paged], function(key, value){
                        //console.log(key, value );
                        html.push( build_product_box( value, maincontainer ) );
                    });

                    if( showpagination == 'yes' && total_results > perpage ){
                        //console.log('ceva' );
                        html.push( build_custom_list_pagination( perpage, total_results, maincontainer ) );
                    }

                    response_elm.html( html.join("\n") );
                    build_rating();
                }
	        });
		}

		if( type == "bestsellers" ){
			box.each( function(){
                maincontainer = $(this);
                response_elm = maincontainer.find(".WooZoneVCSearch-amazon-response");

                var perpage = maincontainer.data('perpage');
                var html = [];
                var results = data['query']['results']['resources']['content']['rss']['channel']['item'];
                var old_results = results;

                if( typeof(results.title) != "undefined" ){
                    results = {
                        0: results
                    };
                }

                var no_results_found = false;
                $.each( results, function(key, value){

                	var old_value = value;
                	value = {};

                	var elm = $( "<div>" + old_value.description + "</div>" );
                	

                    if( elm.find('a').eq(0).find('img').length == 0 ){
                        no_results_found = true;

                        return true;
                    }

                	value['LargeImageUrl'] = elm.find('a').eq(0).find('img').attr('src').replace("._SL160_", "");
                	value['link'] = old_value['link'];

                	var regex = /dp\/(.*)\//g;
					var m;
					while ((m = regex.exec(value['link'])) !== null) {
						if (m.index === regex.lastIndex) {
							regex.lastIndex++;
						}

                		value['ASIN'] = m[1];
					}

					value['Title'] = elm.find(".riRssTitle a").text();

					value['Subtitle'] = elm.find(".riRssContributor").text();

					// try to find the ratings
					elm.find("img").each( function(){
						var that = $(this),
							src = that.attr("src");

						if( src.indexOf("stars-") > 0 ){

							var regex = /stars-(.*)gif/g;
							var m;
							while ((m = regex.exec( that.prop('outerHTML') )) !== null) {
								if (m.index === regex.lastIndex) {
									regex.lastIndex++;
								}

                                m[1] = m[1].split(".")[0].replace("-", ".");

								value['Rating'] = parseFloat(m[1]);
							}

							// try to get number of revewis
							var __ = elm.html().split( that.prop('outerHTML') );
							var regex = /(\(\d+)\)<br>/g;
							var m;
							while ((m = regex.exec( __[1] )) !== null) {
								if (m.index === regex.lastIndex) {
									regex.lastIndex++;
								}

								value['TotalReviews'] = parseInt( m[0].replace("(", '').replace(")", '') );
							}
						}
					});

					value['Price'] = elm.find('font[color="#990000"]').text();
					value['ListPrice'] = elm.find('strike').text();

                	//console.log(value);
                    html.push( build_product_box( value, maincontainer, perpage <= key ? 'hide-default' : '' ) );
                });

                if( maincontainer.data('showpagination') == 'yes' ){
                    html.push( build_feed_pagination( perpage, results.length, maincontainer ) );
                }

                response_elm.html( html.join("\n") );

                build_rating();

                if( no_results_found == true ){
                    response_elm.parent('div').html( "<p>"  + old_results.description + "</p>" );
                }
            });
		}

        //console.log( box, boxid );
    }

    function triggers()
    {
        maincontainer.each(function(){

            var that = $(this),
                box_id = that.data('boxid');

            type = $(this).data('type');

            callback_ids.push( box_id );

            if( type == 'search-box' ){
               search_for_products( that, box_id );

               maincontainer.on('submit', '.WooZoneVCSearch-search-for', function(e){
                    e.preventDefault();

                    var form = $(this),
                        text = form.find("input[type='text']").val();

                    that.data( 'keyword', text );
                    search_for_products( that, box_id );
                });
            }

            if( type == 'custom-list' ){
                asins_loaded = [];
                asins_need_to_be_loaded = [];

                var asins_list              = that.data('asins');
                asins_need_to_be_loaded     = asins_list.split(",");
                all_asins                   = asins_need_to_be_loaded.slice(0);

                var total_results = asins_need_to_be_loaded.length;

                var perpage = that.data('perpage');
                var steps   = Math.ceil( total_results / perpage );

                asins_need_to_be_loaded = [];
                for (var cc = 0; cc <= steps; cc++) {
                    asins_need_to_be_loaded.push( all_asins.slice( (cc * per_page), ((cc * per_page) + per_page) ));                    
                }
                //console.log(asins_need_to_be_loaded, custom_list_paged );

                
                asins_loaded[custom_list_paged] = [];
                // load first from list
                search_for_one_product( that, box_id, asins_need_to_be_loaded[custom_list_paged][0] );

                $('body').on('click', '.WooZoneVCSearch-custom-list-pagination a', function(e){
                    e.preventDefault();

                    var a = $(this),
                        new_paged = a.data('paged');

                    custom_list_paged = new_paged;

                    if( typeof(asins_loaded[custom_list_paged]) == "undefined" ){
                        asins_loaded[custom_list_paged] = [];

                        // load first from list
                        search_for_one_product( that, box_id, asins_need_to_be_loaded[custom_list_paged][0] );
                    }
                    else{

                        var html = [];
                        $.each( asins_loaded[custom_list_paged], function(key, value){
                            //console.log(key, value );
                            html.push( build_product_box( value, maincontainer ) );
                        });

                        if( that.data('showpagination') == 'yes' && total_results > perpage ){
                            //console.log('ceva' );
                            html.push( build_custom_list_pagination( perpage, total_results, maincontainer ) );
                        }

                        response_elm.html( html.join("\n") );
                        build_rating();
                    }
                });
            }

            if( type == 'bestsellers' ){
               search_for_products_rss( $(this), box_id, type );
            }
        });

        
        $("body").on('click', '.WooZoneVCSearch-feed-pagination a', function(e){
            e.preventDefault();

            var that = $(this),
                paged = that.data('paged'),
                maincontainer = that.parents(".WooZoneVCSearch-amazon-products").eq(0),
                perpage = maincontainer.data('perpage'),
                products = maincontainer.find(".WooZoneVCSearch-product");

            // step 1 hide all
            products.addClass('hide-default');

            var start = paged * perpage,
                end = start + perpage - 1;

            $.each( products, function(key, value){

                var _product = $(this);

                if( key >= start && key <= end ){
                    _product.removeClass('hide-default');
                }
            });

            maincontainer.find(".is_on").removeClass('is_on');
            that.addClass('is_on');
        })
    }

    return {
        "callback": callback
    }

})(jQuery);

// build the callback functions

var vc_callbacks = [];
jQuery(".WooZoneVCSearch-amazon-products").each( function(){
    vc_callbacks.push( jQuery(this).data('boxid') );
});

for (var i = vc_callbacks.length - 1; i >= 0; i--) {
    eval( "function callback_" + ( vc_callbacks[i] ) + "( data ){WooZoneVCSearch_frontend.callback( '" + ( vc_callbacks[i] ) + "', data );}");
}
/**/

function search_callback_multi( data ){
    WooZoneVCSearch_frontend.callback( data.InstanceId, data );
}
function search_callback( data ){
    WooZoneVCSearch_frontend.callback( data.InstanceId, data );
}