// Initialization and events code for the app
WooZoneVCSearch_VC_extend = (function ($) {
    "use strict";

    // public
    var debug_level 		= 0,
    	maincontainer 		= null,
    	is_init 			= false;
	
	function triggers()
	{
		maincontainer = $("#wpwrap");

		/*
		if( is_init == true ){
			return true;
		}
		is_init = true;*/

		maincontainer.find(".WooZoneVCSearch_country_dropdown_vc").each(function(e){
			var that = $(this),
				val = that.parents(".WooZoneVCSearch-form-row").eq(0).find("input").val(),
				print_elm = that.find(".WooZoneVCSearch_country_dropdown-current"),
				_val = val.split("#"),
				val = _val[0],
				current = that.find("li[data-country='" + ( val ) + "']");

				that.data( 'country', val );


			if( that.data( 'is_init' ) !== true ){

				that.data( 'is_init', true );

				function change_print_val( current, val )
				{
					var contry_categ = current.parents('.WooZoneVCSearch_country_dropdown_vc').eq(0);
					print_elm.find("img").attr( 'src', current.find('img').attr('src') );
					print_elm.find("span").text( current.find('span').text() );

					that.find("input").val( val );
					contry_categ.data( 'country', val );

					that.find(".is_select").removeClass('is_select');
					current.addClass('is_select');
					that.find("ul").hide();

					contry_categ.trigger("change");

					$.ajax({
						url: ajaxurl,
						type: "POST",
						dataType: "json",
						data: {
							'action'		: 'WooZoneVCSearch_categs_html',
							'country'		: val
						},
						success: function( response ) {
							if( response.status == 'valid' ){
								maincontainer.find(".WooZoneVCSearch-amz-categs-response").html( response.html );
							}
						}
					});
				}

				that.on('click', 'li', function(){
					current = $(this);
					change_print_val( current, current.data('country') );
				});

				print_elm.click(function(){
					that.find("ul").toggle();
				});

				// default
				change_print_val( current, val );

			}
		});

		$('body').on( 'click', '.WooZoneVCSearch-departaments a', function(e){
			e.preventDefault();

			var that 				= $(this),
				parent_li 			= that.parent('li'),
				departament_menu 	= that.parents('.WooZoneVCSearch-departaments').eq(0),
				loader 				= parent_li.find('span.WooZoneVCSearch-loader').eq(0),
				level 				= that.data('level'),
				SearchIndex 		= parent_li.data('searchindex'),
				nodeId 				= that.data('node'),
				country 			= departament_menu.parents('.WooZoneVCSearch-form-row').eq(0).find('.WooZoneVCSearch_country_dropdown_vc').data('country');

			var all_level0 = that.next('ul').find('li[data-level="0"]');
			all_level0.removeClass('is_open').show();

			if( that.hasClass('WooZoneVCSearch-any-dep') ){
				departament_menu.find('.is_open').removeClass('is_open');
				departament_menu.removeClass('tree_is_open');

				departament_menu.find("ul ul").remove();
				return true;
			}

			if( that.data( 'is_init' ) !== true ){
				that.data( 'is_init', true ); 
			}
			else{
				return true;
			}
			
			loader.addClass('show_now');

			$.ajax({
				url: ajaxurl,
				type: "POST",
				dataType: "json",
				data: {
					'action'		: 'WooZoneVCSearch_get_sub_node',
					'node'			: nodeId,
					'SearchIndex'	: SearchIndex,
					'level'			: level,
					'country'		: country
				},
				success: function( response ) {

					if( response.status == 'valid' ){
						var html = [];

						html.push( '<ul>' );

						$.each( response.data, function(ley, value){
							html.push( '<li>' );
							html.push(		'<a href="#" data-node="' + ( value.browseId ) + '" data-level="1">' );
							html.push(		 	'<span class="dashicons dashicons-arrow-left-alt2 WooZoneVCSearch-back-btn"></span>' );
							html.push(			value.label );
							html.push(	'</a>' );
							html.push(	'<span class="WooZoneVCSearch-loader"></span>' );
							html.push( '</li>' );
						});
						html.push( '</ul>' );
						
						departament_menu.find('.is_selected').removeClass('is_selected');

						var row = departament_menu.parents(".WooZoneVCSearch-form-row").eq(0),
							field = row.find(".WooZoneVCSearch-browse-node-field"), 
							searchIndexElm = that.parents('[data-level="0"]'),
							node_id = that.data('node');

						if( that.data('level') == 0 ){
							node_id = 0;
						}
						field.val( country + "#" + searchIndexElm.data('searchindex') + "#" + node_id );

						if( response.data.length == 0 ){
							that.addClass('is_selected');
							loader.removeClass('show_now');

							return true;
						}
						else{

							departament_menu.find('.is_open').removeClass('is_open');

							// add parent class is open to all parent li
							that.parentsUntil(".WooZoneVCSearch-departaments").each( function(){
								var is_parent = $(this);

								if( is_parent.is('li') ){
									is_parent.addClass('is_open');
								}

							});
							
							parent_li.append( html.join("\n") );
							loader.removeClass('show_now');
						}
						
						departament_menu.addClass('tree_is_open');
					}

					if( response.status == 'invalid' ){
						console.error( response.msg );
						that.css('color', 'red');
						loader.removeClass('show_now');
					}

					// hide the rest of level 1 menu
					var is_open_menu_0 = maincontainer.find('li[data-level="0"].is_open');
					is_open_menu_0.each( function(){
						maincontainer.find('li[data-level="0"]').each(function(){
							if( !$(this).hasClass('is_open') ){
								$(this).hide();
							}
						})
					});
				}
			});
		});
		maincontainer.find(".WooZoneVCSearch-typo-wrapper").each( function(){
			var that = $(this),
				input = that.prev("input"),
				defaults = input.val();

			function build_params( row )
			{
				var params = {};
				that.find(".WooZoneVCSearch-typo-row").each( function(){
					var option = $(this),
						option_key = option.data('key');

					params[option_key] = {};

					params[option_key]['family'] = option.find('.WooZoneVCSearch-typo-font-family select').val();
					params[option_key]['size'] = option.find('.WooZoneVCSearch-typo-font-size select').val();
					params[option_key]['weight'] = option.find('.WooZoneVCSearch-typo-font-weight select').val();
					params[option_key]['color'] = option.find('.WooZoneVCSearch-typo-font-color input.wp-color-picker').val();
					params[option_key]['background'] = option.find('.WooZoneVCSearch-typo-background-color input.wp-color-picker').val();
				});

				input.val( JSON.stringify(params).replace(/"/g, "'") );
			}
			
			that.on( 'change', 'select', function(){
				build_params( $(this) );
			});
			that.on( 'change', 'input', function(){
				build_params( $(this) );
			});

			that.find('.WooZoneVCSearch-wp-color-picker-typo-vc').wpColorPicker({
				change: function(event, ui){
					build_params( $(this) );
				}
			});

			// build default based on JSON
			if( defaults ){
				defaults = defaults.replace(/'/g, '"');
				defaults = $.parseJSON( defaults );

				$.each( defaults, function(key, value){
					var row = $('.WooZoneVCSearch-typo-row[data-key="' + ( key ) + '"]');
					row.each(function(){
						$(this).find('.WooZoneVCSearch-typo-font-family select').val( value.family );
						$(this).find('.WooZoneVCSearch-typo-font-size select').val( value.size );
						$(this).find('.WooZoneVCSearch-typo-font-weight select').val( value.weight );
						$(this).find('.WooZoneVCSearch-typo-font-color input.wp-color-picker').val( value.color );
						$(this).find('.WooZoneVCSearch-typo-background-color input.wp-color-picker').val( value.background );
					});
				});
			}

			
		});

		maincontainer.find('.WooZoneVCSearch-select-wrapper').on('click', '.WooZoneVCSearch-select-item:not(.select-on)', function(e) {
        	e.preventDefault();

        	var that = $(this),
        		parent = that.parent();

        	parent.find(".select-on").removeClass('select-on');

        	that.addClass('select-on');
        	parent.next("input").attr('value', ( that.index() + 1 ) );
        });

		function show_hide_pagination()
		{
			var that = $("select.show_pagination"),
				val = that.val(),
				rel = $('.wpb_el_type_dropdown[data-vc-shortcode-param-name="items_per_page"]');

			if( val == 'yes' ){
				rel.show();
			}else{
				rel.hide();
			}
		}
		show_hide_pagination();

		maincontainer.on( 'change', '.wpb-select.show_pagination', function(){
			show_hide_pagination();
		});

		maincontainer.on( 'change', '.WooZoneVCSearch_country_dropdown .search_country', function(){
			var that = $(this),
				val = that.val(),
				amz_categs = maincontainer.find(".WooZoneVCSearch_iw-amazon_categories ul");

			amz_categs.find('li').hide();

			amz_categs.find("li[data-domain='" + ( val ) + "']").show();
		});

		maincontainer.on( 'change', '.WooZoneVCSearch_iw-amazon_categories select', function(){
			var that = $(this),
				val = that.val();

				maincontainer.find(".WooZoneVCSearch_amazon_categories_field").val( val );
		});
		
	}

	// external usage
	return {
		"triggers": triggers
	}
})(jQuery);
