<?php 
class WooZoneVCSearchVCExtend {
	
	public $plugin = null;

	public function __construct() 
	{
		$this->plugin = $GLOBALS['WooZoneVCSearch'];
		
		add_action( 'vc_before_init', array( $this, 'vc_is_inited' ) );		
	}
	
	public function vc_is_inited()
	{
		if( function_exists('vc_add_shortcode_param') ){
			// details here: https://wpbakery.atlassian.net/wiki/spaces/VC/pages/524345/Create+New+Param+Type
			vc_add_shortcode_param( $this->plugin->alias . '_typo_settings', array( $this, 'typo_settings' ) );
			vc_add_shortcode_param( $this->plugin->alias . '_html_radio_settings', array( $this, 'html_radio_settings' ) );
			vc_add_shortcode_param( $this->plugin->alias . '_amazon_categories', array( $this, 'amazon_categories' ) );
			vc_add_shortcode_param( $this->plugin->alias . '_amazon_browsebodes', array( $this, 'amazon_browsebodes' ) );
			vc_add_shortcode_param( $this->plugin->alias . '_country_dropdown', array( $this, 'country_dropdown' ) );

			$this->load_shortcodes();
		}
	}

	public function load_shortcodes()
	{
		foreach( glob( $this->plugin->path( 'APP_ROOT', "/shortcodes/*/init.class.php" ) ) as $pt_init ){
			$this->plugin->cfg['CURRENT_PT_PATH'] = $pt_init;
			$this->plugin->cfg['CURRENT_PT_NAME'] = basename( dirname( $pt_init ) );
			$this->plugin->cfg['CURRENT_PT_URL'] = plugin_dir_url( $this->plugin->cfg['CURRENT_PT_PATH'] );
			require_once $pt_init;
		}  
	}

	public function amazon_browsebodes( $settings, $value )
	{
		$html = array(); 

		$html[] = '<div class="WooZoneVCSearch-form"><div class="WooZoneVCSearch-form-row">';

		$box_id = '';
		$elm_id = $settings['param_name'];

		$html[] =   '<div class="WooZoneVCSearch_country_dropdown WooZoneVCSearch_country_dropdown_vc">';
		$html[] =   	'<div class="WooZoneVCSearch_country_dropdown-current">';
		$html[] =       	'<img src=""> 
							<span></span>
							<div class="dashicons dashicons-arrow-down-alt2"></div>';
		$html[] =   	'</div>';
		$html[] =   	'<ul>';

		foreach (WooZoneVCSearch()->amazon_sites() as $country_code => $country) {

			if( in_array( $settings['feed_name'], array_keys($country['rss'])) ){
				$html[] = '<li data-country="' . ( $country_code ) . '">';
				$html[] =   '<img src="' . ( $country['flag'] ) . '" />';
				$html[] =   '<span>' . $country['label'] . '</span>';
				$html[] = '</li>';
			}
			$cc++;
		}
		$html[] =   	'</ul>'; 
		$html[] =   '</div>';


		$html[] = '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value WooZoneVCSearch-browse-node-field wpb-textinput ' .
			 esc_attr( $settings['param_name'] ) . ' ' .
			 esc_attr( $settings['type'] ) . '_field" type="text" value="' . ( $value ) . '" readonly />';
		
		$html[] =   '<div class="WooZoneVCSearch-amz-categs-response"></div>';

		$html[] = '</div></div>';

		$html[] = '<script> WooZoneVCSearch_VC_extend.triggers(); </script>';
		
		return implode( "\n", $html );
	}

	public function country_dropdown( $settings, $value )
	{
		$html = array();

		$html[] = '<div class="WooZoneVCSearch-form"><div class="WooZoneVCSearch-form-row">';

		$box_id = '';
		$elm_id = $settings['param_name'];

		$html[] =   '<div class="WooZoneVCSearch_country_dropdown WooZoneVCSearch_country_dropdown_field">';
		$html[] = '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .
			 esc_attr( $settings['param_name'] ) . ' ' .
			 esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . ( $value ) . '" />';
		$html[] =   '<div class="WooZoneVCSearch_country_dropdown-current">';
		$html[] =       '<img src=""> 
						<span></span>
						<div class="dashicons dashicons-arrow-down-alt2"></div>';
		$html[] =   '</div>';
		$html[] =   '<ul>';
		foreach (WooZoneVCSearch()->amazon_sites() as $country_code => $country) {
			$html[] = '<li data-country="' . ( $country_code ) . '">';
			$html[] =   '<img src="' . ( $country['flag'] ) . '" />';
			$html[] =   '<span>' . $country['label'] . '</span>';
			$html[] = '</li>';
			$cc++;
		}
		$html[] =   '</ul>'; 
		$html[] =   '</div>';

		$html[] = '</div></div>';

		$html[] = '<script> WooZoneVCSearch_VC_extend.triggers(); </script>';
		
		return implode( "\n", $html );
	}

	public function amazon_categories( $settings, $value )
	{
		$html = array();

		$html[] = '<div class="WooZoneVCSearch-form"><div class="WooZoneVCSearch-form-row">';

		$box_id = '';
		$elm_id = $settings['param_name'];

		$html[] = '<div class="WooZoneVCSearch_iw-amazon_categories">';

		$html[] = '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .
			 esc_attr( $settings['param_name'] ) . ' ' .
			 esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . ( $value ) . '" />';

		$amazon_sites = WooZoneVCSearch()->amazon_sites();
		$amazon_categories = WooZoneVCSearch()->amazon_categories();
		$html[] = '<ul>';
		foreach ($amazon_categories as $domain => $departamens) {

			if( isset($amazon_sites[$domain]) ){
				$html[] =   '<li data-domain="' . ( $domain ) . '">';

				$html[] =       '<img src="' . ( $amazon_sites[$domain]['flag'] ) . '" />';
				$html[] =       '<span>';
				$html[] =           $amazon_sites[$domain]['label'];
				$html[] =       '</span>';
				
				$html[] =       '<select>';
				foreach ($departamens as $key4 => $value4) {
					$html[] =       '<option ' . ( $value == $value4 ? 'selected' : '' ) . ' value="' . ( $value4 ) . '">' . ( $key4 ) . '</option>';
				}
				$html[] =       '</select>';
				$html[] =   '</li>'; 
			}
		}
		$html[] = '</ul>';

		$html[] = '</div>';

		$html[] = '</div></div>';

		$html[] = '<script> WooZoneVCSearch_VC_extend.triggers(); </script>';
		
		return implode( "\n", $html );
	}

	public function html_radio_settings( $settings, $value ) 
	{
		$html = array();

		$html[] = '<div class="WooZoneVCSearch-form"><div class="WooZoneVCSearch-form-row">';

		$box_id = '';
		$elm_id = $settings['param_name'];
		if( isset($settings['options']) && count($settings['options']) > 0 ){
			$html[] = '<div class="WooZoneVCSearch-select-wrapper">';
				foreach ($settings['options'] as $option_key => $option_value ) {
					$html[] =   '<label class="WooZoneVCSearch-select-item ' . ($value == $option_key ? 'select-on' : '') . '">';
					$html[] =       '<span>' . ( $option_value['caption'] ) . '</span>';
					$html[] =       '<div>' . ( $option_value['html'] ) . '</div>';
					$html[] =   '</label>';
				}
			$html[] = '</div>'; 
			$html[] = '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .
			 esc_attr( $settings['param_name'] ) . ' ' .
			 esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . ( $value ) . '" />';
		}

		$html[] = '</div></div>';

		$html[] = '<script> WooZoneVCSearch_VC_extend.triggers(); </script>';
		
		return implode( "\n", $html );
	}

	public function typo_settings( $settings, $value ) 
	{
		$html = array();

		$html[] = '<div class="WooZoneVCSearch-form"><div class="WooZoneVCSearch-form-row">';

		$box_id = '';
		$elm_id = $settings['param_name'];
		/*for debug typography set type to text*/
		$html[] = '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .
			 esc_attr( $settings['param_name'] ) . ' ' .
			 esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';

		if( $settings['options'] ){
			$html[] = '<div class="WooZoneVCSearch-typo-wrapper">';
			$google_fonts = WooZoneVCSearch()->getAllGfonts();

			
			if( !isset($val) || !is_array($val) || count($val) == 0 ){
				$val = array();
				$val = json_decode( str_replace("'", '"', $value), true );
			}
			foreach ($settings['options'] as $option_key => $option_value) {

				// build some defaults if not saved
				if( !isset($val[$option_key]['family']) )              $val[$option_key]['family'] = $option_value['family'];
				if( !isset($val[$option_key]['size']) )                $val[$option_key]['size'] = $option_value['size'];
				if( !isset($val[$option_key]['weight']) )              $val[$option_key]['weight'] = isset($option_value['weight']) ? $option_value['weight'] : '';
				if( !isset($val[$option_key]['color']) )               $val[$option_key]['color'] = $option_value['color'];
				if( !isset($val[$option_key]['background-color']) )    $val[$option_key]['background-color'] = isset($option_value['background-color']) ? $option_value['background-color'] : '';
				
				$html[] =   '<fieldset class="WooZoneVCSearch-typo-row" data-key="' . ( $option_key ) . '">';
				$html[] =       '<legend class="WooZoneVCSearch-typo-title">' . ( $option_value['title'] ) . '</legend>';
				$html[] =       '<div class="WooZoneVCSearch-typo-font-preview">The quick brown fox jumps over the lazy dog</div>';
				$html[] =       '<div class="WooZoneVCSearch-typo-font-family">';
				$html[] =           '<span>Font-family:</span>';
				$html[] =           '<select name="' . ( $box_id ) . '[' . esc_attr( $elm_id ) . '][' . ( $option_key ) . '][family]">';

				if( count($google_fonts) > 0 ){
					foreach ($google_fonts as $font_key => $font ) {
						$html[] = '<option value="' . ( $font_key ) . '" ' . ( isset($val[$option_key]['family']) && $val[$option_key]['family'] == $font ? 'selected' : '' ) . '>' . ( $font ) . '</option>';
					}
				}
				$html[] =           '</select>';
				$html[] =       '</div>';
				
				$html[] =       '<div class="WooZoneVCSearch-typo-font-size">';
				$html[] =           '<span>Size:</span>';
				$html[] =           '<select name="' . ( $box_id ) . '[' . esc_attr( $elm_id ) . '][' . ( $option_key ) . '][size]">';
				foreach ( range( 10, 34 ) as $size ) {
					$html[] =           '<option value="' . ( $size ) . '" ' . ( isset($val[$option_key]['size']) && $val[$option_key]['size'] == $size ? 'selected' : '' ) .'>' . ( $size ) . 'px</option>';
				}
				$html[] =            '</select>';
				$html[] =        '</div>';

				$html[] =       '<div class="WooZoneVCSearch-typo-font-weight">';
				$html[] =           '<span>Weight:</span>';
				$html[] =           '<select name="' . ( $box_id ) . '[' . esc_attr( $elm_id ) . '][' . ( $option_key ) . '][weight]">';
				foreach ( array('normal', 'bold') as $weight ) {
					$html[] =           '<option value="' . ( $weight ) . '" ' . ( isset($val[$option_key]['weight']) && $val[$option_key]['weight'] == $weight ? 'selected' : '' ) .'>' . ( $weight ) . '</option>';
				}
				$html[] =            '</select>';
				$html[] =        '</div>';

				$html[] =       '<div class="WooZoneVCSearch-typo-font-color">';
				$html[] =           '<span>Color:</span>';
				$html[] =           '<input class="WooZoneVCSearch-wp-color-picker-typo-vc" data-alpha="true" name="' . ( $box_id ) . '[' . esc_attr( $elm_id ) . '][' . ( $option_key ) . '][color]" type="text" value="' . ( isset($val[$option_key]['color']) ? $val[$option_key]['color'] : '#000') . '" />';
				$html[] =           '<div class="WooZoneVCSearch-wp-color-picker-wrapper"></div>';
				$html[] =        '</div>';


				if( $val[$option_key]['background-color'] != "" ){
					$html[] =       '<div class="WooZoneVCSearch-typo-background-color">';
					$html[] =           '<span>Background-color:</span>';
					$html[] =           '<input class="WooZoneVCSearch-wp-color-picker-typo-vc" data-alpha="true" name="' . ( $box_id ) . '[' . esc_attr( $elm_id ) . '][' . ( $option_key ) . '][background-color]" type="text" value="' . ( isset($val[$option_key]['background']) ? $val[$option_key]['background'] : '#000') . '" />';
					$html[] =           '<div class="WooZoneVCSearch-wp-color-picker-wrapper"></div>';
					$html[] =        '</div>';
				}



				$html[] =   '</fieldset>';
			}
			$html[] = '</div>';
		}
		
		$html[] = '</div></div>';

		$html[] = '<script> WooZoneVCSearch_VC_extend.triggers(); </script>';

		return implode( "\n", $html );
	}
}

$WooZoneVCSearchVCExtend = new WooZoneVCSearchVCExtend();