<?php 
class WooZoneVCSearchShortcodeFeeds {

	public $the_plugin = null;
	public $shortcode_alias = '';
	public $feeds = array();

	public $the_feed = array();

	public function __construct( $the_feed=array() ) 
	{

		$this->the_feed = $the_feed;
		$this->the_plugin = $GLOBALS['WooZoneVCSearch'];

		$this->shortcode_alias = $this->the_plugin->alias . 'feed' . '_' . $this->the_feed['id'];

		// We safely integrate with VC with this hook
		add_action( 'vc_after_init', array( $this, 'vc_init' ) );

		add_shortcode( $this->shortcode_alias, array( $this, 'shortcode_output' ) );

		add_action( 'wp_ajax_' . $this->the_plugin->alias . '_save_stats', array( $this, 'save_stats' ) );
		add_action( 'wp_ajax_nopriv_' . $this->the_plugin->alias . '_save_stats', array( $this, 'save_stats' ) );
	}

	public function vc_init()
	{
		// Check if Visual Composer is installed
		if ( ! defined( 'WPB_VC_VERSION' ) ) {
			// Display notice that Visual Compser is required
			add_action('admin_notices', array( $this, 'showVcVersionNotice' ));
			return;
		}

		vc_map(array(
			"name" => __("Azon - " . $this->the_feed['name'], "my-text-domain"),
			"base" => $this->shortcode_alias, 
			"class" => "",
			"description" => 'Add Products from Amazon into any page.',
			"category" => __("Azon Addons", "my-text-domain"),
			'admin_enqueue_js' => WooZoneVCSearch_asset_url( 'vc_extend.js' ),
			"icon" => $this->the_feed['icon'],
			"admin_label" => false,
			"params" => array(

				array(
					'type' => $this->the_plugin->alias . '_amazon_browsebodes',
					'heading' => __( 'Amazon Category & nodeID:', 'js_composer' ),
					'param_name' => 'browsenode',
					'value' => 'com#electronics#0',
					'feed_name' => $this->the_feed['id']
				),
						
				array(
					'type' => 'dropdown',
					'heading' => __( 'Show pagination:', 'js_composer' ),
					'param_name' => 'show_pagination',
					'std' => 'yes',
					'save_always' => true,
					'value' => array(
						'YES' => 'yes',
						'NO' => 'no'
					),
					'description' => __( 'Set if you want to have pagination on products', 'js_composer' ),
				),

				array(
					'type' => 'dropdown',
					'heading' => __( 'Products per page:', 'js_composer' ),
					'param_name' => 'items_per_page',
					'std' => 3,
					'value' => range(1, 10),
					'description' => __( 'Select the number of products per page.', 'js_composer' ),
				),

				array(
					'type' => $this->the_plugin->alias . '_html_radio_settings',
					'heading' => __( 'Products per Column:', 'js_composer' ),
					'param_name' => 'products_per_column',
					'value' => 3,
					'description' => __( 'Select how many products to display per column', 'js_composer' ),
					'options'           => array(
						1 => array(
							'caption' => '1 item / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="1">
								<i></i>
							</div>'
						),

						2 => array(
							'caption' => '2 items / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="2">
								<i></i>
								<i></i>
							</div>'
						),

						3 => array(
							'caption' => '3 items / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="3">
								<i></i>
								<i></i>
								<i></i>
							</div>'
						),

						4 => array(
							'caption' => '4 items / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="4">
								<i></i>
								<i></i>
								<i></i>
								<i></i>
							</div>'
						),

						5 => array(
							'caption' => '5 items / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="5">
								<i></i>
								<i></i>
								<i></i>
								<i></i>
								<i></i>
							</div>'
						),

						6 => array(
							'caption' => '6 items / column',
							'html' => '<div class="WooZoneVCSearch-grid-size" data-size="6">
								<i></i>
								<i></i>
								<i></i>
								<i></i>
								<i></i>
								<i></i>
							</div>'
						),
					)
				),

				array(
					"type" => $this->the_plugin->alias . '_typo_settings',
					"holder" => "div",
					"class" => "",
					'options'           => array(

						'product_title' => array(
							'title' => 'Product Title',
							'size' => '14px',
							'weight' => 'bold',
							'color' => '#131313',
							'family' => 'Droid Sans',
						),

						'product_sub_title' => array(
							'title' => 'Product Sub Title',
							'size' => '14px',
							'weight' => 'bold',
							'color' => '#131313',
							'family' => 'Droid Sans',
						),

						'nb_of_reviews' => array(
							'title' => 'Number of reviews',
							'size' => '12px',
							'weight' => 'normal',
							'color' => '#ff7209',
							'family' => 'Droid Sans',
						),

						'buy_btn' => array(
							'title' => 'Buy button',
							'size' => '12px',
							'color' => '#fff',
							'family' => 'Droid Sans',
							'background-color' => '#ff7209'
						),

						'regular_price' => array(
							'title' => 'Regular price text',
							'size' => '14px',
							'color' => '#afafaf',
							'family' => 'Droid Sans',
						),

						'sale_price' => array(
							'title' => 'Sale price text',
							'size' => '20px',
							'color' => '#121212',
							'family' => 'Droid Sans',
						),

						'pagination_color' => array(
							'title' => 'Pagination Color - Active State',
							'size' => '20px',
							'color' => '#121212',
							'family' => 'Droid Sans',
						),

						'pagination_default' => array(
							'title' => 'Pagination Color - Default Color ',
							'size' => '20px',
							'color' => '#121212',
							'family' => 'Droid Sans',
						),
					),
					"heading" => __("Typography", "my-text-domain"),
					"param_name" => "typo",
					"value" => __("", "my-text-domain"),
					"description" => __("Description for foo param.", "my-text-domain")
				)
			)
		));
	}

	public function custom_frontend_style()
	{
		$custom_uniqid = uniqid();
		$settings = $this->the_plugin->settings['setup'];
		$css = array();

		//echo json_encode( $settings ) ;

		// custom cases here ...
		if( isset($settings['products_per_column']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-amazon-response  {
					grid-template-columns: repeat(" . ( $settings['products_per_column'] ) . ", minmax(0, 1fr));
				}
			";
		}

		if( isset($settings['template_typography']['headline']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-box-title {
					font-family: '" . ( $settings['template_typography']['headline']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['headline']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['headline']['weight'] ) . ";
					color: " . ( $settings['template_typography']['headline']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['product_title']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-title a {
					font-family: '" . ( $settings['template_typography']['product_title']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['product_title']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['product_title']['weight'] ) . ";
					color: " . ( $settings['template_typography']['product_title']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['product_sub_title']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-subtitle {
					font-family: '" . ( $settings['template_typography']['product_sub_title']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['product_sub_title']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['product_sub_title']['weight'] ) . ";
					color: " . ( $settings['template_typography']['product_sub_title']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['nb_of_reviews']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-rating-totals {
					font-family: '" . ( $settings['template_typography']['nb_of_reviews']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['nb_of_reviews']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['nb_of_reviews']['weight'] ) . ";
					color: " . ( $settings['template_typography']['nb_of_reviews']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['regular_price']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-price div {
					font-family: '" . ( $settings['template_typography']['regular_price']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['regular_price']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['regular_price']['weight'] ) . ";
					color: " . ( $settings['template_typography']['regular_price']['color'] ) . ";
				}
			";
		}


		if( isset($settings['template_typography']['sale_price']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-price .WooZoneVCSearch-new-price {
					font-family: '" . ( $settings['template_typography']['sale_price']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['sale_price']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['sale_price']['weight'] ) . ";
					color: " . ( $settings['template_typography']['sale_price']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['buy_btn']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . ".WooZoneVCSearch-amazon-products .WooZoneVCSearch-product .WooZoneVCSearch-button {
					font-family: '" . ( $settings['template_typography']['buy_btn']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['buy_btn']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['buy_btn']['weight'] ) . ";
					color: " . ( $settings['template_typography']['buy_btn']['color'] ) . ";
					background-color: " . ( $settings['template_typography']['buy_btn']['background'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['pagination_default']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-custom-list-pagination a, 
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-feed-pagination a {
					font-family: '" . ( $settings['template_typography']['pagination_default']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['pagination_default']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['pagination_default']['weight'] ) . ";
					color: " . ( $settings['template_typography']['pagination_default']['color'] ) . ";
				}
			";
		}

		if( isset($settings['template_typography']['pagination_color']) ){
			$css[] = "
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-custom-list-pagination a.is_on, 
				body .WooZoneVCSearch-uniq-" . ( $custom_uniqid ) . " .WooZoneVCSearch-feed-pagination a.is_on {
					font-family: '" . ( $settings['template_typography']['pagination_color']['family'] ) . "';
					font-size: " . ( $settings['template_typography']['pagination_color']['size'] ) . "px;
					font-weight: " . ( $settings['template_typography']['pagination_color']['weight'] ) . ";
					color: " . ( $settings['template_typography']['pagination_color']['color'] ) . ";
					border-color: " . ( $settings['template_typography']['pagination_color']['color'] ) . ";
				}
			";
		}

		$buffer = implode( "\n", $css );

		// Remove comments
		$buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $buffer);
		 
		// Remove space after colons
		$buffer = str_replace(': ', ':', $buffer);
		 
		// Remove whitespace
		$buffer = str_replace(array("\r\n", "\r", "\n", "\t", '    ', '    '), '', $buffer);

		echo "<style>" . ( $buffer ) . "</style>";

		return $custom_uniqid;
	}

	public function add_styles()
	{
		wp_enqueue_style( WooZoneVCSearch()->alias . '-Droid+Sans', 'https://fonts.googleapis.com/css?family=Droid+Sans:400,700', array(), '1.0' );
		wp_enqueue_style( WooZoneVCSearch()->alias . '-amazon-styles', WooZoneVCSearch()->assetUrl('frontend.css'), array(), '1.0' );
		wp_enqueue_style( WooZoneVCSearch()->alias . '-rating', WooZoneVCSearch()->assetUrl('star-rating-svg.css'), array(), '1.0' );

		wp_enqueue_script( WooZoneVCSearch()->alias . '-amazon-rating', WooZoneVCSearch()->assetUrl('jquery.star-rating-svg.js'), array( 'jquery' ) );
		wp_enqueue_script( WooZoneVCSearch()->alias . '-amazon', WooZoneVCSearch()->assetUrl('frontend.js'), array( 'jquery' ) );

		wp_localize_script( WooZoneVCSearch()->alias . '-amazon', WooZoneVCSearch()->alias . '_custom', array(
			'ajaxurl' => admin_url('admin-ajax.php'),
			'translation' => array(
				'no_results_found' => esc_html__('No more results found..', 'WooZoneVCSearch'),
				'nb_results' => esc_html__('Around {nb_results} results found..', 'WooZoneVCSearch'),
				'prev_page' => esc_html__('Previous page', 'WooZoneVCSearch'),
				'next_page' => esc_html__('Next page', 'WooZoneVCSearch')
			),
		));

		if( count($this->the_plugin->settings['setup']['template_typography']) > 0 ){
			$google_fonts = array();
			foreach ($this->the_plugin->settings['setup']['template_typography'] as $key => $value) {
				$google_fonts[] = str_replace( " ", "+", $value['family']);
			}

			$google_fonts = array_unique( $google_fonts );

			wp_enqueue_style( WooZoneVCSearch()->alias . '-googlefonts', '//fonts.googleapis.com/css?family=' . implode( "|", $google_fonts ), array(), '1.0' );
		}
	}

	public function shortcode_output( $atts )
	{
		extract( shortcode_atts( array(
			'show_pagination' => 'no',
			'items_per_page' => 2,
			'asins' => '',
			'products_per_column' => 1,
			'search_category' => 'All',
			'browsenode'	=> 'com#electronics#0',
			'typo' => "{'headline':{'family':'Droid Sans','size':'11','weight':'bold','color':'#000'},'product_title':{'family':'Droid Sans','size':'14','weight':'bold','color':'#131313'},'product_sub_title':{'family':'Droid Sans','size':'14','weight':'bold','color':'#131313'},'nb_of_reviews':{'family':'Droid Sans','size':'12','weight':'normal','color':'#ff7209'},'buy_btn':{'family':'Droid Sans','size':'12','weight':'normal','color':'#fff','background':'#ff7209'},'regular_price':{'family':'Droid Sans','size':'14','weight':'normal','color':'#afafaf'},'sale_price':{'family':'Droid Sans','size':'20','weight':'normal','color':'#121212'}}",
		), $atts ) );

		if( trim($typo) != "" ){
			$typo = str_replace( "'", '"', $typo );
			$typo = json_decode( $typo, true );
			$this->the_plugin->settings['setup']['template_typography'] = $typo;
		}

		$__ = explode( "#", $browsenode );
		$search_country = $__[0];
		$search_category = $__[1];
		$browsenode = $__[2]; 

		$this->the_plugin->settings['setup']['items_per_page'] = $items_per_page;
		$this->the_plugin->settings['setup']['show_pagination'] = $show_pagination;
		$this->the_plugin->settings['setup']['products_per_column'] = $products_per_column;
		$this->the_plugin->settings['setup']['search_country'] = $search_country;
		$this->the_plugin->settings['setup']["geo_targeting"]['default_aff'] = $search_country;
		$this->the_plugin->settings['setup']['searchindex'] = $search_category;
		$this->the_plugin->settings['setup']['browsenode'] = $browsenode;

		$this->add_styles();

		$style_id = $this->custom_frontend_style();

		$user_country = $this->the_plugin->get_country_perip_external();

		// force for testing request 
		$user_country = isset($_GET['force_country']) && strlen($_GET['force_country']) < 5 ? $_GET['force_country'] : $user_country;

 		$amz_sites = $this->the_plugin->amazon_sites();
		$amz_site = $amz_sites[$this->the_plugin->settings['setup']['search_country']];
		$amzUser = $this->the_plugin->amzForUser( $user_country, $this->the_plugin->settings['setup']['search_country'] );
 		$amz_site['rss'] = $amz_site['rss'][$this->the_feed['id']]['link'];

 		if( $this->the_plugin->settings['setup']['browsenode'] > 0 ){
 			$amz_site['rss'] = $amz_site['rss'] . $this->the_plugin->settings['setup']['browsenode'] . '/';
 		}

		$html = array();

 		$debug = isset($_GET['debug']) ? true : false;
		if( $debug === true ){

			$rss_url = str_replace( '{SearchIndex}', $this->the_plugin->settings['setup']['searchindex'], $amz_site['rss'] );
			$site_url = str_replace( 'gp/rss/', '', $rss_url );
			$html[] = '<code style="display: block; padding-left: 20px;">Feed Name: ' . ( $this->the_feed['name'] ) . ', ' . ( $this->the_feed['id'] ) . ' </code>';
			$html[] = '<code style="display: block; padding-left: 20px;">items_per_page: ' . ( $this->the_plugin->settings['setup']['items_per_page'] ) . '</code>';
			$html[] = '<code style="display: block; padding-left: 20px;">products_per_column: ' . ( $this->the_plugin->settings['setup']['products_per_column'] ) . '</code>';
			$html[] = '<code style="display: block; padding-left: 20px;">searchindex: ' . ( $this->the_plugin->settings['setup']['searchindex'] ) . '</code>';
			$html[] = '<code style="display: block; padding-left: 20px;">apiurl: ' . ( $rss_url ) . '</code>';
			$html[] = '<code style="display: block; padding-left: 20px;">';
			$html[] = 	'site url: <a href="' . ( $site_url ) . '">link</a>';
			$html[] = '</code>';
		}
		$html[] = '<div class="' . ( WooZoneVCSearch()->alias ) . '-amazon-products WooZoneVCSearch-uniq-' . ( $style_id ) . '" data-type="bestsellers" data-country="' . ( $user_country ) . '" data-boxid="' . ( $style_id ) . '" data-amzsite="' . ( $this->the_plugin->settings['setup']['search_country'] ) . '" data-apiurl="' . ( $amz_site['rss'] ) . '" data-placeholder="' . ( WooZoneVCSearch()->assetUrl('images/placeholder.png') ) . '" data-perpage="' . ( $this->the_plugin->settings['setup']['items_per_page']) . '" data-asins="' . ( $asins ) . '" data-btntext="' . ( $this->the_plugin->settings['setup']['button_text'] ) . '" data-buyurl="' . ($this->the_plugin->buy_url( $user_country, $amzUser ) ) . '" data-searchindex="' . ( $this->the_plugin->settings['setup']['searchindex'] ) . '" data-column="' . ( $products_per_column ) . '" data-showpagination="' . ( $this->the_plugin->settings['setup']['show_pagination'] ) . '" data-browsenode="' . ( $this->the_plugin->settings['setup']['browsenode'] ) . '">';

		$html[] =   '<div class="' . ( WooZoneVCSearch()->alias ) . '-amazon-response"></div>';
		$html[] =   '<div class="' . ( WooZoneVCSearch()->alias ) . '-amazon-pag-response"></div>';
		//$html[] =   '<div class="' . ( WooZoneVCSearch()->alias ) . '-number-results-found"></div>';
		$html[] = '</div>';

		echo implode( "\n", $html );
	}

	public function save_stats()
	{
		$params = isset($_REQUEST['params']) ? $_REQUEST['params'] : array();
		if( $params && count($params) > 0 ){
			$ip = $this->the_plugin->get_client_ip();

			WooZoneVCSearch()->db->insert(
				WooZoneVCSearch()->db->prefix . 'WooZoneVCSearch_stats',
				array(
					'action'        => isset($params['action']) ? $params['action'] : '',
					'keyword'       => isset($params['keyword']) ? $params['keyword'] : '',
					'amazon_site'   => isset($params['amzsite']) ? $params['amzsite'] : '',
					'country'       => isset($params['country']) ? $params['country'] : '',
					'url'           => isset($params['url']) ? $params['url'] : '',
					'ip'            => $ip
				),
				array(
					'%s',
					'%s',
					'%s',
					'%s',
					'%s',
					'%s'
				)
			);
		}

		die("ok");
	}
}


$WooZoneVCSearchFeeds = array(
	'bestsellers' 	=> array(
		'label' => 'Best Sellers',
		'icon' => WooZoneVCSearch_asset_url( 'icons/bestseller.png' )
	),

	'new' 	=> array(
		'label' => 'New Releases',
		'icon' => WooZoneVCSearch_asset_url( 'icons/new.png' )
	),

	'movers' 	=> array(
		'label' => 'Movers & Shakers',
		'icon' => WooZoneVCSearch_asset_url( 'icons/movers.png' )
	),

	'wished' 	=> array(
		'label' => 'Most Wished For',
		'icon' => WooZoneVCSearch_asset_url( 'icons/wished.png' )
	),

	'gifted' 	=> array(
		'label' => 'Gift Ideas',
		'icon' => WooZoneVCSearch_asset_url( 'icons/gifted.png' )
	)
);

foreach ( $WooZoneVCSearchFeeds as $feed_id => $feed ) {
	$the_feed = array( 
		'id' 	=> $feed_id,
		'name' 	=> $feed['label'],
		'icon' 	=> $feed['icon']
	);
	new WooZoneVCSearchShortcodeFeeds( $the_feed );
}